/** \File NvmEeprom.cpp
 * \copyright (c) 2025 len0rd
 * \date   2025-01-09
 */
#include "NvmEeprom.hpp"
#include <cstddef>
#include "EEPROM.h"

bool JoystickAxisCalibration::valid() const {
    return min < mid < max;
}

void writeNvm(const NonVolatileMemory& nvm) {
    for (size_t ii = 0; ii < sizeof(NonVolatileMemory); ii++) {
        EEPROM.write(ii, nvm.rawBytes[ii]);
    }
}

void writeCalibration(const JoystickCalibration& cal) {
    NonVolatileMemory nvm = {};
    nvm.calData.joystickCal = cal;
    writeNvm(nvm);
}

void readNvm(NonVolatileMemory& nvm) {
    nvm.calData.validMarker = 0;
    for (size_t ii = 0; ii < sizeof(NonVolatileMemory); ii++) {
        nvm.rawBytes[ii] = EEPROM.read(ii);
    }
}
